import { addSchema } from "@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta";
import { Model, setSchema, createTypeMetaGuard } from "@kubernetes-models/base";
import { register } from "@kubernetes-models/validate";
const schemaId = "internal.packaging.carvel.dev.v1alpha1.InternalPackageMetadata";
const schema = {
    "type": "object",
    "properties": {
        "apiVersion": {
            "type": "string",
            "enum": [
                "internal.packaging.carvel.dev/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "InternalPackageMetadata"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        },
        "spec": {
            "properties": {
                "categories": {
                    "items": {
                        "type": "string"
                    },
                    "type": "array",
                    "nullable": true
                },
                "displayName": {
                    "type": "string",
                    "nullable": true
                },
                "iconSVGBase64": {
                    "type": "string",
                    "nullable": true
                },
                "longDescription": {
                    "type": "string",
                    "nullable": true
                },
                "maintainers": {
                    "items": {
                        "properties": {
                            "name": {
                                "type": "string",
                                "nullable": true
                            }
                        },
                        "type": "object"
                    },
                    "type": "array",
                    "nullable": true
                },
                "providerName": {
                    "type": "string",
                    "nullable": true
                },
                "shortDescription": {
                    "type": "string",
                    "nullable": true
                },
                "supportDescription": {
                    "type": "string",
                    "nullable": true
                }
            },
            "type": "object"
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
export class InternalPackageMetadata extends Model {
    constructor(data) {
        super({
            apiVersion: InternalPackageMetadata.apiVersion,
            kind: InternalPackageMetadata.kind,
            ...data
        });
    }
}
InternalPackageMetadata.apiVersion = "internal.packaging.carvel.dev/v1alpha1";
InternalPackageMetadata.kind = "InternalPackageMetadata";
InternalPackageMetadata.is = createTypeMetaGuard(InternalPackageMetadata);
setSchema(InternalPackageMetadata, schemaId, () => {
    addSchema();
    register(schemaId, schema);
});
